Index: trunk/LMDZ.COMMON/libf/muphypluto
===================================================================
--- trunk/LMDZ.COMMON/libf/muphypluto	(revision 3564)
+++ trunk/LMDZ.COMMON/libf/muphypluto	(revision 3564)
@@ -0,0 +1,1 @@
+link ../../LMDZ.PLUTO/libf/muphypluto/
Index: trunk/LMDZ.PLUTO/libf/dynphy_lonlat/phypluto/leapfrog_nogcm_pluto.F
===================================================================
--- trunk/LMDZ.PLUTO/libf/dynphy_lonlat/phypluto/leapfrog_nogcm_pluto.F	(revision 3563)
+++ trunk/LMDZ.PLUTO/libf/dynphy_lonlat/phypluto/leapfrog_nogcm_pluto.F	(revision 3564)
@@ -22,5 +22,4 @@
       use exner_milieu_m, only: exner_milieu
       use cpdet_mod, only: cpdet,tpot2t,t2tpot
-      use sponge_mod, only: callsponge,mode_sponge,sponge
        use comuforc_h
       USE comvert_mod, ONLY: ap,bp,pressure_exner,presnivs,
@@ -34,5 +33,5 @@
       USE callkeys_mod
       USE tracer_h, ONLY: igcm_n2,igcm_ch4_gas,igcm_co_gas,
-     .                  igcm_prec_haze,igcm_haze 
+     .                  igcm_prec_haze,igcm_haze
 
 
@@ -85,6 +84,6 @@
 
 ! ADAPTATION GCM POUR CP(T)
-      REAL temp(ip1jmp1,llm)                 ! temperature  
-      REAL tsurpk(ip1jmp1,llm)               ! cpp*T/pk  
+      REAL temp(ip1jmp1,llm)                 ! temperature
+      REAL tsurpk(ip1jmp1,llm)               ! cpp*T/pk
 
 !     nogcm
@@ -115,5 +114,5 @@
       INTEGER itau,itaufinp1,iav
 !      INTEGER  iday ! jour julien
-      REAL       time 
+      REAL       time
 
       REAL  SSUM
@@ -135,5 +134,5 @@
       data first/.true./
       logical ok_sync
-      parameter (ok_sync = .true.) 
+      parameter (ok_sync = .true.)
       logical physics
 
@@ -144,18 +143,18 @@
       REAL :: flxw(ip1jmp1,llm)  ! flux de masse verticale
 
-      REAL psmean                    ! pression moyenne 
+      REAL psmean                    ! pression moyenne
       REAL pqn2mean                 ! moyenne globale ps*qco
       REAL pqch4mean                 ! moyenne globale ps*qch4
       REAL pqcomean                 ! moyenne globale ps*qco
-      REAL pqhazemean        
-      REAL pqprechazemean              
+      REAL pqhazemean
+      REAL pqprechazemean
       REAL qmean_ch4                    ! mass mean mixing ratio vap ch4
       REAL qmean_co                    ! mass mean mixing ratio vap co
-      REAL qmean_haze 
-      REAL qmean_prechaze 
+      REAL qmean_haze
+      REAL qmean_prechaze
       REAL pqch4(ip1jmp1)           ! average methane mass index : ps*qch4
       REAL pqco(ip1jmp1)           ! average CO mass index : ps*q_co
-      REAL pqhaze(ip1jmp1) 
-      REAL pqprechaze(ip1jmp1) 
+      REAL pqhaze(ip1jmp1)
+      REAL pqprechaze(ip1jmp1)
 
       REAL p0                        ! pression de reference
@@ -167,5 +166,5 @@
 c+jld variables test conservation energie
       REAL ecin(ip1jmp1,llm),ecin0(ip1jmp1,llm)
-C     Tendance de la temp. potentiel d (theta)/ d t due a la 
+C     Tendance de la temp. potentiel d (theta)/ d t due a la
 C     tansformation d'energie cinetique en energie thermique
 C     cree par la dissipation
@@ -186,5 +185,5 @@
 
       logical , parameter :: flag_verif = .false.
-      
+
       ! for CP(T)
       real :: dtec
@@ -214,5 +213,5 @@
       endif
       itaufinp1 = itaufin +1
-      
+
 
 
@@ -272,7 +271,7 @@
 
 c------------------
-c     Preparing mixing of pressure and tracers in nogcm 
+c     Preparing mixing of pressure and tracers in nogcm
 c     kpd=exp(-z/H)  Needed to define a reference pressure :
-c     P0=pmean/globalaverage(kpd)  
+c     P0=pmean/globalaverage(kpd)
 c     thus P(i) = P0*exp(-z(i)/H) = P0*kpd(i)
 c     It is checked that globalaverage2d(Pi)=pmean
@@ -281,5 +280,5 @@
       ENDDO
       p00d=globaverage2d(kpd) ! mean pres at ref level
-      tau_ps = tau_n2 ! constante de rappel for pressure  (s) 
+      tau_ps = tau_n2 ! constante de rappel for pressure  (s)
 
       PRINT*,'igcm_n2 = ',igcm_n2
@@ -300,8 +299,8 @@
 c   -----
 
-      jD_cur = jD_ref + day_ini - day_ref +                             
-     &          (itau+1)/day_step 
-      jH_cur = jH_ref + start_time +                                    
-     &          mod(itau+1,day_step)/float(day_step) 
+      jD_cur = jD_ref + day_ini - day_ref +
+     &          (itau+1)/day_step
+      jH_cur = jH_ref + start_time +
+     &          mod(itau+1,day_step)/float(day_step)
       jD_cur = jD_cur + int(jH_cur)
       jH_cur = jH_cur - int(jH_cur)
@@ -330,9 +329,9 @@
       ! Purely Matsuno time stepping
          IF( MOD(itau,iconser) .EQ.0.AND.  forward    ) conser = .TRUE.
-   
-         IF( MOD(itau,iphysiq ).EQ.0.AND..NOT.forward 
+
+         IF( MOD(itau,iphysiq ).EQ.0.AND..NOT.forward
      s          .and. physics        ) apphys = .TRUE.
       ELSE
-         ! Leapfrog/Matsuno time stepping 
+         ! Leapfrog/Matsuno time stepping
            IF( MOD(itau   ,iconser) .EQ. 0  ) conser = .TRUE.
            IF( MOD(itau+1,iphysiq).EQ.0.AND.physics) apphys=.TRUE.
@@ -370,13 +369,13 @@
          CALL geopot  ( ip1jmp1, teta  , pk , pks,  phis  , phi   )
 
-         jD_cur = jD_ref + day_ini - day_ref +                        
-     &          (itau+1)/day_step 
+         jD_cur = jD_ref + day_ini - day_ref +
+     &          (itau+1)/day_step
 
          ! AS: we make jD_cur to be pday
          jD_cur = int(day_ini + itau/day_step)
 
-         jH_cur = jH_ref + start_time +                               
-     &          mod(itau+1,day_step)/float(day_step) 
-         jH_cur = jH_ref + start_time +                               
+         jH_cur = jH_ref + start_time +
+     &          mod(itau+1,day_step)/float(day_step)
+         jH_cur = jH_ref + start_time +
      &          mod(itau,day_step)/float(day_step)
          jD_cur = jD_cur + int(jH_cur)
@@ -392,5 +391,5 @@
      $               dufi,dvfi,dtetafi,dqfi,dpfi  )
 
-c      ajout des tendances physiques 
+c      ajout des tendances physiques
 c      ------------------------------
 
@@ -401,10 +400,10 @@
 c         CALL pression (ip1jmp1,ap,bp,ps,p)
 c         CALL massdair(p,masse)
-   
+
          ! 1) Saving pressure and mass of N2 tracer in each mess (kg) before Horizontal mixing of pressure
          DO ij=1,ip1jmp1
-               oldps(ij)=ps(ij)              
+               oldps(ij)=ps(ij)
          ENDDO
-          
+
          !DO l=1, llm
          !  DO ij=1,ip1jmp1
@@ -461,5 +460,5 @@
          ! 6) Horizontal redistribution of other tracers
          ! intermediaire de calcul si methane or CO
-         if ((methane).or.(carbox)) then 
+         if ((methane).or.(carbox)) then
               psmean= globaverage2d(ps)
          endif
@@ -537,5 +536,5 @@
        ENDIF ! of IF( apphys )
 
-        
+
 c   ********************************************************************
 c   ********************************************************************
@@ -559,5 +558,5 @@
             ENDIF
 
-            IF( itau. EQ. itaufinp1 ) then  
+            IF( itau. EQ. itaufinp1 ) then
               if (flag_verif) then
                 write(79,*) 'ucov',ucov
@@ -585,5 +584,5 @@
                   iav=0
                ENDIF
-               
+
 !              ! Ehouarn: re-compute geopotential for outputs
                CALL geopot(ip1jmp1,teta,pk,pks,phis,phi)
@@ -664,5 +663,5 @@
                         leapf =  .TRUE.
                         dt  =  2.*dtvr
-                        GO TO 2 
+                        GO TO 2
                    END IF ! of IF (forward)
             ELSE
@@ -697,5 +696,5 @@
 
                forward =  .FALSE.
-               IF( itau. EQ. itaufinp1 ) then  
+               IF( itau. EQ. itaufinp1 ) then
                  abort_message = 'Simulation finished'
                  call abort_gcm(modname,abort_message,0)
@@ -707,5 +706,5 @@
         if (ok_iso_verif) then
            call check_isotopes_seq(q,ip1jmp1,'leapfrog 1698')
-        endif !if (ok_iso_verif) then  
+        endif !if (ok_iso_verif) then
 
               IF(MOD(itau,iperiod).EQ.0 .OR. itau.EQ.itaufin) THEN
@@ -751,5 +750,5 @@
                 endif
 
-              ENDIF ! of IF(MOD(itau,iecri         ).EQ.0) 
+              ENDIF ! of IF(MOD(itau,iecri         ).EQ.0)
 
               IF(itau.EQ.itaufin) THEN
@@ -805,5 +804,5 @@
          END DO
        END DO
-       
+
        DO i=1,iim
          globaverage2d = globaverage2d + var(i,1)*aire(i,1)