Index: trunk/LMDZ.PLUTO/libf/phypluto/initracer.F90
===================================================================
--- trunk/LMDZ.PLUTO/libf/phypluto/initracer.F90	(revision 3572)
+++ trunk/LMDZ.PLUTO/libf/phypluto/initracer.F90	(revision 3585)
@@ -123,12 +123,4 @@
          ALLOCATE(is_recomb_qotf(nqtot))
        ENDIF
-       IF (.NOT. allocated(is_condensable)) allocate(is_condensable(nq)) !LT
-       IF (.NOT. allocated(is_rgcs)) allocate(is_rgcs(nq)) !LT
-       IF (.NOT. allocated(constants_mass)) allocate(constants_mass(nq))
-       IF (.NOT. allocated(constants_delta_gasH)) allocate(constants_delta_gasH(nq))
-       IF (.NOT. allocated(constants_Tref)) allocate(constants_Tref(nq))
-       IF (.NOT. allocated(constants_Pref)) allocate(constants_Pref(nq))
-       IF (.NOT. allocated(constants_RLVTT_generic)) allocate(constants_RLVTT_generic(nq))
-       IF (.NOT. allocated(constants_RCPV_generic)) allocate(constants_RCPV_generic(nq))
 
        !! initialization
@@ -148,15 +140,4 @@
        radius(:)=0.
        qext(:)=0.
-
-       ! For condensable tracers, by Lucas Teinturier and Noé Clément (2022)
-
-       is_condensable(:)= 0
-       is_rgcs(:) = 0
-       constants_mass(:)=0
-       constants_delta_gasH(:)=0
-       constants_Tref(:)=0
-       constants_Pref(:)=0
-       constants_RLVTT_generic(:)=0
-       constants_RCPV_generic(:)=0
 
        rho_q(:) = 0. !need to be init here if we want to read it from modern traceur with get_tracdat
@@ -403,38 +384,7 @@
       if (is_master) close(407)
 
-      ! Get specific data of condensable tracers
-      do iq=1,nq
-        if((is_condensable(iq)==1)) then
-                write(*,*) "There is a specie which is condensable, for generic condensation : ", noms(iq)
-                write(*,*) 'looking specie parameters for : ',noms(iq)(1:len(trim(noms(iq)))-4)
-                ! call specie_parameters_table(noms(iq)(1:len(trim(noms(iq)))-4))
-                ! constants_mass(iq)=m
-                ! constants_delta_gasH(iq)=delta_gasH
-                ! constants_Tref(iq)=Tref
-                ! constants_Pref(iq)=Pref
-                ! constants_RLVTT_generic(iq)=RLVTT_generic
-                ! constants_RCPV_generic(iq)=RCPV_generic
-        else
-                write(*,*) "This tracer is not condensable, for generic condensation :  : ", noms(iq)
-                write(*,*) "We keep condensable constants at zero"
-        endif !(is_condensable(iq)==1) .and. (index(noms(iq),"vap") .ne. 0))
-      enddo ! iq=1,nq
-
       ! Calculate number of species in the chemistry
       nesp = sum(is_chim)
       write(*,*) 'Number of species in the chemistry nesp = ',nesp
-
-      ! Calculate number of generic tracers
-      ngt = sum(is_condensable)
-      write(*,*) 'Number of generic tracer is  ngt = ',ngt
-
-      ! Calculate number of radiative generic condensable species
-      n_rgcs = sum(is_rgcs)
-      write(*,*)'Number of Radiative Generic Condensable Species is n_rgcs = ',n_rgcs
-      if (n_rgcs> ngt/2) then
-        write(*,*) 'You have more Radiative Generic Condensable Species than Generic Condensable Species'
-        write(*,*)'This is not possible: check your Modern traceur.def'
-        call abort_physic("initracer, issue with # of RGCS and GCS")
-      endif
 
       ! Calculate number of microphysical tracer
@@ -461,19 +411,25 @@
       write(*,*) "lw_n2 = ", lw_n2
 
-      if (haze) then
+      if (callmufi) then
+        if (optichaze) then
+          iaero_haze = 2
+          write(*,*) 'Microphysical moment model'
+          write(*,*) '--- number of haze aerosol = ', iaero_haze
+        endif ! end optichaze
+      
+      elseif (haze) then
         ! the sedimentation radius remains radius(igcm_haze)
         if (fractal) then
-           nmono=nb_monomer
+          nmono=nb_monomer
         else
-           nmono=1
+          nmono=1
         endif ! end fractal
-
-        ia=0
+        
+        ia = 0
         if (optichaze) then
-          ia=ia+1
-          iaero_haze=ia
+          ia = ia + 1
+          iaero_haze = ia
           write(*,*) '--- number of haze aerosol = ', iaero_haze
-
-          block=0  ! Only one type of haze is active : the first one set in traceur.def
+          block = 0 ! Only one type of haze is active : the first one set in traceur.def
           do iq=1,nq
             tracername=noms(iq)
@@ -484,8 +440,8 @@
               write(*,*) "i_haze=",i_haze
               write(*,*) "Careful: if you set many haze traceurs in &
-                traceur.def,only ",tracername," will be radiatively active &
-                (first one in traceur.def)"
+              traceur.def,only ",tracername," will be radiatively active &
+              (first one in traceur.def)"
             endif
-          enddo
+            enddo
         endif ! end optichaze
       endif ! end callmufi or haze
@@ -602,14 +558,4 @@
               is_recomb_qotf(iq)
           end if
-          !option is_condensable (LT)
-          if (index(tracline,'is_condensable=') /=0) then
-            read(tracline(index(tracline,'is_condensable=') &
-              +len('is_condensable='):),*) is_condensable(iq)
-            write(*,*) ' Parameter value (traceur.def) :'// &
-              ' is_condensable=', is_condensable(iq)
-          else
-              write(*,*) ' Parameter value (default)     :'// &
-              ' is_condensable=', is_condensable(iq)
-          endif
           !option radius
           if (index(tracline,'radius=') .ne. 0) then
@@ -632,14 +578,4 @@
               ' rho=', rho_q(iq)
           endif
-          !option is_rgcs
-          if (index(tracline,'is_rgcs') .ne. 0) then
-            read(tracline(index(tracline,'is_rgcs=') &
-              +len('is_rgcs='):),*) is_rgcs(iq)
-            write(*,*)'Parameter value (traceur.def) :'// &
-              'is_rgcs=',is_rgcs(iq)
-          else
-            write(*,*)'Parameter value (default) : '// &
-              'is_rgcs = ',is_rgcs(iq)
-          endif
       end subroutine get_tracdat
 